/* The Netlogon Project

   addfw.c - add firewall rules allowing access for a single IP address
   
   $Id: addfw.c,v 1.5 2001/03/08 14:54:51 kent Exp $
   
   Copyright (C) 2000,2001 UNIT, Linkping University
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

main(int argc, char **argv)
{
  char buf[256];
  int rc = 0;
  char *ip;
  struct in_addr ip_struct;
  int  masq = 0;

  /* Argument count */

  if (argc == 2)
    {
      ip = argv[1];
    }
  else if (argc == 3)
    {
      ip = argv[2];
      if (!strcmp(argv[1],"-m"))
	{
	  masq = 1;
	}
    }
  else
    {
      exit(1);
    }

  /* Argument length and syntax*/
  if (strlen(ip) > 32)
    {
      exit(1);
    }

  if (!inet_aton(ip, &ip_struct))
    {
      exit(1);
    }

  /* Step 1: Add to fw-users chain */
  if (masq)
    {
      sprintf(buf, "/sbin/ipchains -A fw-users -s %s -j MASQ", ip);
    }
  else
    {
      sprintf(buf, "/sbin/ipchains -A fw-users -b -s %s -j ACCEPT", ip);
    }
  if (system(buf) <0)
    {
      rc = 1;
    }

  /* Step 2: Add to in-users chain */
  sprintf(buf, "/sbin/ipchains -A in-users -s %s -j ACCEPT", ip);
  if (system(buf) <0)
    {
      rc = 1;
    }

  exit(rc);
}
