/* The Netlogon Project

   ledshow.c - client to communicate with the LED daemon
   
   $Id: ledshow.c,v 1.3 2001/03/08 14:54:51 kent Exp $
   
   Copyright (C) 2000,2001 UNIT, Linkping University
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>


/* Socket interface */

#define SOCKNAME "/opt/netlogon/sock/ledd"
#define CMD_NOTICE 1
#define CMD_ERROR 2

int s;
void init_socket(void)
{
   if ((s = socket(AF_UNIX,SOCK_DGRAM,0)) < 0)
     return;
}

int send_socket(int type, int value)
{
  struct sockaddr_un  addr;
  int addrlen;
  char cmdbuf[2];
  int n;

  bzero((char *)&addr,sizeof(addr));
  addr.sun_family = AF_UNIX;
  strcpy(addr.sun_path, SOCKNAME);
  addrlen = strlen(addr.sun_path) + sizeof(addr.sun_family);
  
  cmdbuf[0] = type;
  cmdbuf[1] = value;
  n = sendto(s,cmdbuf,2,0,(struct sockaddr *) &addr,addrlen);
}

/* MAIN */

int main(int argc, char *argv[])
{
  int type, value;

  if (argc != 3)
    exit(1);

  if (!strcmp(argv[1], "notice"))
    type = CMD_NOTICE;
  else
    type = CMD_ERROR;

  value = atoi(argv[2]);

  init_socket();
  send_socket(type, value);

  return 0;
}
