# The Netlogon Project
#
# log.py - logging
#
# $Id: log.py,v 1.4 2001/03/08 14:54:51 kent Exp $
#
# Copyright (C) 2000,2001 UNIT, Linkping University
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#
# NETLOGON logger
#

import path

import string
from syslog import *
import os

import conf

facility_dict = \
              {
                  "kern": LOG_KERN,
                  "user": LOG_USER,
                  "mail": LOG_MAIL,
                  "daemon": LOG_DAEMON,
                  "auth": LOG_AUTH,
                  "lpr": LOG_LPR,
                  "news": LOG_NEWS,
                  "uucp": LOG_UUCP,
                  "cron": LOG_CRON,
                  "local0": LOG_LOCAL0,
                  "local1": LOG_LOCAL1,
                  "local2": LOG_LOCAL2,
                  "local3": LOG_LOCAL3,
                  "local4": LOG_LOCAL4,
                  "local5": LOG_LOCAL5,
                  "local6": LOG_LOCAL6,
                  "local7": LOG_LOCAL7,
                  }

# Omvandla text till facility (None om sdan saknas)
def text_to_facility(txt):
    try:
        return facility_dict[string.lower(txt)]
    except:
        return None

# Meningslst att gra en klass, d syslog-modulen sjlv innehller en massa globala tillstnd

_ident = "netlogon"
_facility = LOG_USER

def init(prog_name):
    # Get information from [syslog] in general.conf
    c = conf.Config("general")
    _ident = c.get_default("syslog", "ident", "netlogon")
    _facility = text_to_facility(c.get_default("syslog", "facility", "user"))
    if _facility is None:
        _facility = LOG_USER
        
    openlog(_ident + "/" + prog_name,
            LOG_PID,
            _facility)

def log(message, priority = LOG_INFO, led_error = None, led_notice = None):
    syslog(priority, message)
    try:
        if led_error:
            os.system("%s/ledshow error %s" % (path.bindir, led_error))
        elif led_notice:
            os.system("%s/ledshow notice %s" % (path.bindir, led_notice))
    except:
        pass
