# The Netlogon Project
#
# simple_snmp.py - simple access to pysnmp functions
#
# $Id: simple_snmp.py,v 1.2 2001/03/08 14:54:51 kent Exp $
#
# Copyright (C) 2000,2001 UNIT, Linkping University
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import pysnmp
import string

class Session:
    def __init__(self, agent, community = "public"):
        self.__agent = agent
        self.__community = community
        self.__s = pysnmp.session(agent, community)
    

    def get(self, oid):
        encoded_oid = self.__s.encode_oid(self.__s.str2nums(oid))
        packet = self.__s.encode_request('GETREQUEST', [encoded_oid], [])
        respone = self.__s.send_and_receive(packet)
        (rec_oids, rec_vals) = self.__s.decode_response(respone, "GETRESPONSE")

        if len(rec_oids) <> 1 or len(rec_vals) <> 1:
            raise KeyError

        if self.__s.decode_value(rec_oids[0]) <> oid:
            raise KeyError

        return self.__s.decode_value(rec_vals[0])

    __getitem__ = get
    

# Convert an ethernet address (e.g. "00:01:96:CB:EB:80") to a string of
# integers separated by dots (e.g. "")

def ether_to_oid_string(ether):
    if len(ether) <> 17: raise ValueError
    hexlist = string.split(ether, ":")
    if len(hexlist) <> 6: raise ValueError
    intlist = map(lambda x: str(string.atoi(x,16)), hexlist)
    return string.join(intlist, ".")

